<?php

namespace DHLExpressGlobalWS;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'docTypeRef_ProcessShipmentRequestType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ProcessShipmentRequestType',
            'docTypeRef_ClientDetailType2' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ClientDetailType2',
            'Request' => '\\DHLExpressGlobalWS\\StructType\\Request',
            'ServiceHeaderType' => '\\DHLExpressGlobalWS\\StructType\\ServiceHeaderType',
            'docTypeRef_Content' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_Content',
            'docTypeRef_DangerousGoods' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_DangerousGoods',
            'docTypeRef_RequestedShipmentType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_RequestedShipmentType',
            'docTypeRef_ShipmentInfoType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ShipmentInfoType',
            'ShipmentPrepaidTotalCharge' => '\\DHLExpressGlobalWS\\StructType\\ShipmentPrepaidTotalCharge',
            'docTypeRef_InternationDetailType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_InternationDetailType',
            'docTypeRef_CommoditiesType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_CommoditiesType',
            'ExportDeclaration' => '\\DHLExpressGlobalWS\\StructType\\ExportDeclaration',
            'ExportLineItems' => '\\DHLExpressGlobalWS\\StructType\\ExportLineItems',
            'ExportLineItemType' => '\\DHLExpressGlobalWS\\StructType\\ExportLineItemType',
            'InvoiceDeclarationTexts' => '\\DHLExpressGlobalWS\\StructType\\InvoiceDeclarationTexts',
            'InvoiceDeclarationText' => '\\DHLExpressGlobalWS\\StructType\\InvoiceDeclarationText',
            'InvoiceSignatureDetails' => '\\DHLExpressGlobalWS\\StructType\\InvoiceSignatureDetails',
            'OtherCharges' => '\\DHLExpressGlobalWS\\StructType\\OtherCharges',
            'OtherCharge' => '\\DHLExpressGlobalWS\\StructType\\OtherCharge',
            'Remarks' => '\\DHLExpressGlobalWS\\StructType\\Remarks',
            'Remark' => '\\DHLExpressGlobalWS\\StructType\\Remark',
            'docTypeRef_OnDemandDeliveryOptions' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_OnDemandDeliveryOptions',
            'docTypeRef_ShipType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ShipType',
            'docTypeRef_ContactInfoType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ContactInfoType',
            'docTypeRef_ContactInfoType1' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ContactInfoType1',
            'docTypeRef_ContactType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ContactType',
            'docTypeRef_ContactType1' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ContactType1',
            'docTypeRef_AddressType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_AddressType',
            'docTypeRef_AddressType1' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_AddressType1',
            'docTypeRef_RegistrationNumbers' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_RegistrationNumbers',
            'docTypeRef_RegistrationNumber' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_RegistrationNumber',
            'docTypeRef_BankDetails' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_BankDetails',
            'docTypeRef_BankDetail' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_BankDetail',
            'docTypeRef_PackagesType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_PackagesType',
            'docTypeRef_RequestedPackagesType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_RequestedPackagesType',
            'docTypeRef_DimensionsType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_DimensionsType',
            'Billing' => '\\DHLExpressGlobalWS\\StructType\\Billing',
            'Services' => '\\DHLExpressGlobalWS\\StructType\\Services',
            'Service' => '\\DHLExpressGlobalWS\\StructType\\Service',
            'DocumentImages' => '\\DHLExpressGlobalWS\\StructType\\DocumentImages',
            'DocumentImage' => '\\DHLExpressGlobalWS\\StructType\\DocumentImage',
            'LabelOptions' => '\\DHLExpressGlobalWS\\StructType\\LabelOptions',
            'CustomerLogo' => '\\DHLExpressGlobalWS\\StructType\\CustomerLogo',
            'CustomerBarcode' => '\\DHLExpressGlobalWS\\StructType\\CustomerBarcode',
            'DetachOptions' => '\\DHLExpressGlobalWS\\StructType\\DetachOptions',
            'ShipmentReferences' => '\\DHLExpressGlobalWS\\StructType\\ShipmentReferences',
            'ShipmentReferenceType' => '\\DHLExpressGlobalWS\\StructType\\ShipmentReferenceType',
            'BespokeLabelData' => '\\DHLExpressGlobalWS\\StructType\\BespokeLabelData',
            'LabelBarcodes' => '\\DHLExpressGlobalWS\\StructType\\LabelBarcodes',
            'LabelBarcode' => '\\DHLExpressGlobalWS\\StructType\\LabelBarcode',
            'LabelTextEntries' => '\\DHLExpressGlobalWS\\StructType\\LabelTextEntries',
            'LabelTextEntry' => '\\DHLExpressGlobalWS\\StructType\\LabelTextEntry',
            'PackageReferences' => '\\DHLExpressGlobalWS\\StructType\\PackageReferences',
            'PackageReferenceType' => '\\DHLExpressGlobalWS\\StructType\\PackageReferenceType',
            'docTypeRef_ShipmentNotifications' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ShipmentNotifications',
            'docTypeRef_ShipmentNotification' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ShipmentNotification',
            'docTypeRef_RateRequestType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_RateRequestType',
            'docTypeRef_ClientDetailType3' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ClientDetailType3',
            'RequestType' => '\\DHLExpressGlobalWS\\StructType\\RequestType',
            'docTypeRef_RequestedShipmentType2' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_RequestedShipmentType2',
            'docTypeRef_ShipType2' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ShipType2',
            'docTypeRef_AddressType2' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_AddressType2',
            'docTypeRef_PackagesType2' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_PackagesType2',
            'docTypeRef_RequestedPackagesType2' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_RequestedPackagesType2',
            'docTypeRef_WeightType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_WeightType',
            'docTypeRef_DimensionsType2' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_DimensionsType2',
            'Billing2' => '\\DHLExpressGlobalWS\\StructType\\Billing2',
            'Services2' => '\\DHLExpressGlobalWS\\StructType\\Services2',
            'Service2' => '\\DHLExpressGlobalWS\\StructType\\Service2',
            'ProductsAndServices2' => '\\DHLExpressGlobalWS\\StructType\\ProductsAndServices2',
            'ProductAndServices' => '\\DHLExpressGlobalWS\\StructType\\ProductAndServices',
            'LandedCostType' => '\\DHLExpressGlobalWS\\StructType\\LandedCostType',
            'ItemsType' => '\\DHLExpressGlobalWS\\StructType\\ItemsType',
            'ItemType' => '\\DHLExpressGlobalWS\\StructType\\ItemType',
            'GoodsCharacteristicsType' => '\\DHLExpressGlobalWS\\StructType\\GoodsCharacteristicsType',
            'GoodsCharacteristicType' => '\\DHLExpressGlobalWS\\StructType\\GoodsCharacteristicType',
            'AdditionalQuantityDefinitionsType' => '\\DHLExpressGlobalWS\\StructType\\AdditionalQuantityDefinitionsType',
            'AdditionalQuantityDefinitionType' => '\\DHLExpressGlobalWS\\StructType\\AdditionalQuantityDefinitionType',
            'ShipmentMonetaryAmountType' => '\\DHLExpressGlobalWS\\StructType\\ShipmentMonetaryAmountType',
            'ChargesType' => '\\DHLExpressGlobalWS\\StructType\\ChargesType',
            'docTypeRef_DeleteResponseType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_DeleteResponseType',
            'ResponseType' => '\\DHLExpressGlobalWS\\StructType\\ResponseType',
            'docTypeRef_NotificationType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_NotificationType',
            'docTypeRef_DeleteRequestType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_DeleteRequestType',
            'docTypeRef_ClientDetailType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ClientDetailType',
            'docTypeRef_RateResponseType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_RateResponseType',
            'docTypeRef_ProviderType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ProviderType',
            'docTypeRef_NotificationType3' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_NotificationType3',
            'docTypeRef_WarningType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_WarningType',
            'docTypeRef_ServiceType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ServiceType',
            'TotalNet' => '\\DHLExpressGlobalWS\\StructType\\TotalNet',
            'Charges' => '\\DHLExpressGlobalWS\\StructType\\Charges',
            'docTypeRef_TotalNetType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_TotalNetType',
            'docTypeRef_TotalChargeTypes' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_TotalChargeTypes',
            'TotalChargeType' => '\\DHLExpressGlobalWS\\StructType\\TotalChargeType',
            'docTypeRef_ChargesType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ChargesType',
            'docTypeRef_ChargeType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ChargeType',
            'ChargeBreakdown' => '\\DHLExpressGlobalWS\\StructType\\ChargeBreakdown',
            'Breakdown' => '\\DHLExpressGlobalWS\\StructType\\Breakdown',
            'docTypeRef_ItemsType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ItemsType',
            'docTypeRef_ItemType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ItemType',
            'Notification' => '\\DHLExpressGlobalWS\\StructType\\Notification',
            'docTypeRef_ServiceAreaType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ServiceAreaType',
            'docTypeRef_ExchangeRateType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ExchangeRateType',
            'ExchangeRate' => '\\DHLExpressGlobalWS\\StructType\\ExchangeRate',
            'docTypeRef_ShipmentDetailType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_ShipmentDetailType',
            'docTypeRef_Response' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_Response',
            'docTypeRef_NotificationType2' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_NotificationType2',
            'docTypeRef_PackagesResultsType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_PackagesResultsType',
            'docTypeRef_PackageResultType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_PackageResultType',
            'docTypeRef_LabelImageType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_LabelImageType',
            'docTypeRef_Documents' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_Documents',
            'docTypeRef_Document' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_Document',
            'docTypeRef_TotalNet' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_TotalNet',
            'docTypeRef_Charges' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_Charges',
            'AdditionalInformation' => '\\DHLExpressGlobalWS\\StructType\\AdditionalInformation',
            'docTypeRef_OriginServiceAreaType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_OriginServiceAreaType',
            'docTypeRef_DestinationServiceAreaType' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_DestinationServiceAreaType',
            'ServiceHandlingFeatureCodes' => '\\DHLExpressGlobalWS\\StructType\\ServiceHandlingFeatureCodes',
            'BarcodeInfo' => '\\DHLExpressGlobalWS\\StructType\\BarcodeInfo',
            'docTypeRef_TrackingNumberBarcodes' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_TrackingNumberBarcodes',
            'docTypeRef_TrackingNumberBarcode' => '\\DHLExpressGlobalWS\\StructType\\DocTypeRef_TrackingNumberBarcode',
            'EstimatedDeliveryDate' => '\\DHLExpressGlobalWS\\StructType\\EstimatedDeliveryDate',
            'PickupDetails' => '\\DHLExpressGlobalWS\\StructType\\PickupDetails',
        );
    }
}
